#include <stdio.h>
#include <unistd.h>
#include <time.h>
#include <dlfcn.h>

#define SECONDSOFF 20000000

long tv_sec, tv_usec;
int tz_minuteswest, tz_dsttime;

struct timeval {
    long tv_sec;
    long tv_usec;
    } tv;

struct timezone {
    int tz_minuteswest;
    int tz_dsttime;
    } tz;

int gettimeofday (struct timeval *tv, struct timezone *tz) {
    void *handle;
    int tip, (*oldtimer)(char);
    char *error;
    
    handle = dlopen ("/lib/libc.so.6", RTLD_LAZY);
    if (!handle) {
	fputs (dlerror (), stderr);
	exit(1);
	}
    oldtimer = dlsym(handle, "time");
    if ((error = dlerror()) != NULL) {
	fprintf (stderr, "%s\n", error);
	}
    tip=(int)(*oldtimer)((int)NULL);
    dlclose(handle);
    tv->tv_sec = (tip-SECONDSOFF);
    return(0);
}

time_t time(time_t *t) {
    void *handle;
    int tip, (*oldtimer)(char);
    char *error;
    
    handle = dlopen ("/lib/libc.so.6", RTLD_LAZY);
    if (!handle) {
	fputs (dlerror (), stderr);
	exit(1);
	}
    oldtimer = dlsym(handle, "time");
    if ((error = dlerror()) != NULL) {
	fprintf (stderr, "%s\n", error);
	}
    tip=(*oldtimer)((int)NULL);
    dlclose(handle);
    t = (int)(tip-SECONDSOFF);
    return((int)t);
}
       